.flash version=5 filename="jpreplacer.swf" fps=24

.sprite jpmain
	.action:
		_root.current_subtitle = "";
		_root.searched_subtitle = null;
		_root.search_lock = false;

		_root.jpn_flash_fps = %%flash_fps%%;
		_root.jpn_match_tekitou = %%match_tekitou%%;
		_root.jpn_subtitleframe_update = %%update_subtitle_frames%%;

		function jp_char_replace(src_chr)
		{
			var from_chrs = "ABCDEFGHIJKLMNOPQRSTUWXYZ:;-,.'\"";
			var dest_chrs = "abcdefghijklmnopqrstuwxyz       ";
			var new_chr = src_chr;

			for(var i=0; i<from_chrs.length; i++)
			{
				if(src_chr == from_chrs.substring(i, 1+i))
				{
					new_chr = dest_chrs.substring(i, 1+i);
					break;
				}
			}

			if(new_chr == " ") new_chr = "";
			return new_chr;
		}
		_root.jp_char_replace = jp_char_replace;

		function jp_compare_replace(src_text)
		{
			var new_text = "";
			if(!_root.jpn_match_tekitou) return src_text;

			for(var i=0; i<src_text.length; i++)
			{
				new_text = new_text + jp_char_replace(src_text.substring(i, 1+i));
			}

			return new_text;
		}
		_root.jp_compare_replace = jp_compare_replace;

		function replace_subtitle()
		{
			var subtitle_mc = _root.centerBox.subtitleTextHolder.TextContents;
			if(subtitle_mc.subtitleBoxTextBoxBG.text != _root.current_subtitle)
			{
				_root.current_subtitle = subtitle_mc.subtitleBoxTextBoxBG.text;
				if(_root.current_subtitle != _root.searched_subtitle && !_root.search_lock)
				{
					var jp_subtitle = _root.search_jptext(_root.current_subtitle);

					subtitle_mc.subtitleBoxTextBoxBG.text = jp_subtitle;
					subtitle_mc.subtitleBoxTextBox.text = jp_subtitle;
				}
			}
		}

		function search_jptext(src_text)
		{
			_root.searched_subtitle = src_text;
			var new_text = src_text;
			var work_src_text = jp_compare_replace(src_text);

			_root.search_lock = true;
			for(var i=0; i<_root.en_text.length; i++)
			{
				if(_root.en_text[i] == work_src_text.substring(0, _root.en_text[i].length) && _root.jp_text[i].length > 0)
				{
					new_text = _root.jp_text[i];
					if(new_text.substring(0,1) == "[")
					{
						_root.NumFramesToShowSubtitle = new_text.substring(1,4) * _root.jpn_flash_fps;
						new_text = new_text.substring(5, new_text.length);
					}
					else if(_root.jpn_subtitleframe_update)
					{
						var jp_multiplier = 0.05;
						var jp_max_delay = 1.4;
						var jp_bound = 350.0;

						var jp_delay = (new_text.length * 1.5 / jp_bound) * (new_text.length * 1.5 / jp_bound) + 0.9;
						if(jp_delay > jp_max_delay) jp_delay = jp_max_delay;
						if(jp_delay < 1.0) jp_delay = 1.0;

						_root.NumFramesToShowSubtitle = new_text.length * 2 * jp_multiplier * jp_delay * _root.jpn_flash_fps;
						if(_root.NumFramesToShowSubtitle < _root.jpn_flash_fps) _root.NumFramesToShowSubtitle = _root.jpn_flash_fps;
					}
					break;
				}
			}
			_root.search_lock = false;

			return new_text;
		}
		_root.search_jptext = search_jptext;
		_root.jpmain.onEnterFrame = replace_subtitle;

		var en_text = new Array();
		var jp_text = new Array();

//%%transtext%%

		for(var ii=0; ii<en_text.length; ii++)
		{
			en_text[ii] = jp_compare_replace(en_text[ii]);
		}
		_root.en_text = en_text;
		_root.jp_text = jp_text;

	.end
.end

.frame 1
	.put jpmain
.end