/*
 * Created by SharpDevelop.
 * User: xxxx
 * Date: 2007/09/22
 * Time: 16:05
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.IO;
using System.Text;
using System.Runtime.InteropServices;

namespace subtitle_convert
{
	/// <summary>
	/// Description of INIHandler.
	/// </summary>
	public class INIHandler
	{
		[DllImport("KERNEL32.DLL")]
		public static extern uint GetPrivateProfileString(
			string lpAppName,
			string lpKeyName,
			string lpDefault,
			StringBuilder lpReturnedString,
			uint nSize,
			string lpFileName
		);

		[DllImport("KERNEL32.DLL", EntryPoint="GetPrivateProfileStringA")]
		public static extern uint GetPrivateProfileStringByByteArray(
			string lpAppName,
			string lpKeyName,
			string lpDefault,
			byte [] lpReturnedString,
			uint nSize,
			string lpFileName
		);

		[DllImport("KERNEL32.DLL")]
		public static extern uint GetPrivateProfileInt(
			string lpAppName,
			string lpKeyName,
			int nDefault,
			string lpFileName
		);

		[DllImport("KERNEL32.DLL")]
		public static extern uint WritePrivateProfileString(
			string lpAppName,
			string lpKeyName,
			string lpString,
			string lpFileName
		);
	}
}
